//+------------------------------------------------------------------+
//|                                                   BreakoutH4.mq4 |
//|                                                           Pokman |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Pokman"
#property link      ""

extern double Lots=0.5;
extern int SL=0;
extern int Risk=0;
extern bool BiProfit=false;
extern bool MultiLot=false;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
string sname;
int minlot,dig;
double hcena,lcena,profit,bident,sident,kredit;
bool pokyny=false;
int init()
  {
//----
 kredit=AccountBalance();
 sname=Symbol();  
 minlot=MarketInfo(sname,MODE_MINLOT);// minimalni objem
 dig=1; // standart ucet
 if (minlot==0.01) dig=2; // micro
 if (minlot==0.001) dig=3; // nano

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  double bipr;
  int nn,stop;
//----
   if (DayOfWeek()!=1) pokyny=false;
   if (!pokyny && DayOfWeek()==1 && TimeHour(iTime(sname,PERIOD_H4,1))==0) // jeste nejsou zadany pokyny, je pondeli, H4 svice s casem 0:00 dokreslena 
    {
     if (OrdersTotal()>0)
     for(nn=0;nn<OrdersTotal();nn++)
     { // smaz cekaci pokyny z minuleho tydne
      OrderSelect(nn, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==sname && (OrderType()==OP_SELLSTOP|| OrderType()==OP_BUYSTOP)) OrderDelete(OrderTicket());
     } 
     if (Risk==0 && MultiLot && AccountBalance()>(kredit*2)) {Lots=Lots*2;kredit=AccountBalance();} // navys objem - MultiLot je True
     hcena=iHigh(sname,PERIOD_H4,1)+(10*Point);// Long = High + 10 pips
     lcena=iLow(sname,PERIOD_H4,1)-(10*Point);// Short = Low - 10 pips
     if (SL==0) stop=(hcena-lcena)*MathPow(10,MarketInfo(sname,MODE_DIGITS)); else stop=SL;// SL v bodech
     profit=((hcena-lcena)-(20*Point))*2;// PT = dvojnasobek rozsahu svice
     if (Risk>0) Lots=NormalizeDouble(((AccountBalance()/(100/Risk))/stop)/MarketInfo(sname,MODE_TICKVALUE),dig);// vypocitej objem dle Risku %
     // zadej nove cekaci pokyny
     if (Lots>MarketInfo(sname,MODE_MAXLOT)) Lots=MarketInfo(sname,MODE_MAXLOT);// kontroluj maximalni objem
     bident=OrderSend(sname,OP_BUYSTOP,Lots,hcena,1,hcena-(stop*Point),hcena+profit,"BuyStop",123);
     sident=OrderSend(sname,OP_SELLSTOP,Lots,lcena,1,lcena+(stop*Point),lcena-profit,"SellStop",123);
     pokyny=true;
     return(0);
     Comment("SL= ",SL);
    }
//---- BiProfit
    if (!BiProfit) return(0);
    if (OrdersTotal()>0)
     for(nn=0;nn<OrdersTotal();nn++)
     { 
      OrderSelect(nn, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==sname && OrderType()==OP_SELL) 
       {
        bipr=OrderOpenPrice()-OrderTakeProfit();
        if (Bid<=OrderOpenPrice()-(bipr/2) && OrderStopLoss()!=OrderOpenPrice()) {OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0);
        OrderClose(OrderTicket(),NormalizeDouble(OrderLots()/2,dig),Ask,1);}// presun SL na BE a ukonci polovinu
       }
      if (OrderSymbol()==sname && OrderType()==OP_BUY) 
       {
        bipr=OrderTakeProfit()-OrderOpenPrice();
        if (Ask>=OrderOpenPrice()+(bipr/2) && OrderStopLoss()!=OrderOpenPrice()) {OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0);
        OrderClose(OrderTicket(),NormalizeDouble(OrderLots()/2,dig),Bid,1);}// presun SL na BE a ukonci polovinu
       }
     } 

   return(0);
  }
//+------------------------------------------------------------------+